<template>
  <div>
    <v-form @submit.prevent>
      <v-card-item>
        <v-card class="mb-3">
          <h2 class="m-3">Mitarbeiter Account erstellen</h2>
        </v-card>

        <p style="color: limegreen" v-if="createSuccess">Mitarbeiter wurde erfolgreich angelegt.</p>
        <v-alert
            v-show="errorMessage"
            color="error"
            class="mb-4"
            closable>
          <p>Falscher Username oder Passwort</p>
        </v-alert>

        <v-text-field
            v-model="user.username"
            :rules="usernameRules"
            label="Username"
            type="text"
            required
            variant="outlined"
            maxlength="255"
            autocomplete="username"/>

        <v-text-field
            v-model="user.email"
            :rules="emailRules"
            label="E-Mail"
            type="email"
            required
            variant="outlined"
            maxlength="255"
            autocomplete="email"/>

        <v-text-field
            v-model="user.firstName"
            label="Vorname"
            type="text"
            required
            variant="outlined"
            maxlength="255"/>

        <v-text-field
            v-model="user.lastName"
            label="Nachname"
            type="text"
            required
            variant="outlined"
            maxlength="255"/>

        <v-text-field
            v-model="user.birthday"
            label="Geburtstag"
            type="date"
            required
            variant="outlined"
            maxlength="255"/>

        <v-select
            v-show="authStore.user.role === 'MANAGER'"
            label="Rolle"
            :items="['USER']"
            v-model="user.role"
        ></v-select>

        <v-select
            v-show="authStore.user.role === 'ADMIN'"
            label="Rolle"
            :items="['ADMIN', 'MANAGER', 'USER']"
            v-model="user.role"
        ></v-select>

        <v-select
            label="Abteilung"
            :items="departments"
            v-model="user.department"
        ></v-select>

<!--        <v-select
            v-if="user.role === 'MANAGER'"
            label="Geleitete Abteilung"
            :items="departments"
            v-model="user.managedDepartment"
        ></v-select>-->

        <v-btn type="submit" color="blue-darken-4" block class="mb-2" @click="registerUser">Erstellen</v-btn>
        <v-btn color="secondary" block class="mb-2" @click="router.push('/dashboard')">Zurück zur Startseite</v-btn>
        <v-snackbar location="bottom end">
          Ein unbekannter Fehler ist aufgetreten. Bitte versuchen Sie es später erneut.
        </v-snackbar>
      </v-card-item>
    </v-form>
  </div>
</template>

<script setup>

import {computed, onMounted, ref, toRaw} from "vue";
import {useUserStore} from "@/stores/userStore";
import {useAuthStore} from "@/stores/authStore";
import {router} from "@/router";
import {useDepartmentStore} from "@/stores/departmentStore";

const userStore = useUserStore();
const authStore = useAuthStore();
const departmentStore = useDepartmentStore();


const errorMessage = ref(false);
const createSuccess = ref(false);
const departments = computed(() => toRaw(departmentStore.departments));
const user = ref({
  username: "",
  email: "",
  password: "iperia123",
  firstName: "",
  lastName: "",
  birthday: "",
  role: "",
  department: "",
  managedDepartment: ""
});

const usernameRules = computed(() => [
  value => {
    if (value) return true;

    return 'Username is required.';
  },
  value => {
    if (value && value.length >= 2) return true;

    return 'Username muss aus mindestens 2 Zeichen bestehen.';
  },
]);

const emailRules = computed(() => [
  value => {
    if (value) return true

    return 'E-mail is required.'
  },
  value => {
    if (/.+@.+\..+/.test(value)) return true

    return 'E-mail must be valid.'
  },
]);

onMounted(async () => {
  await departmentStore.getDepartments();
})

async function registerUser() {
  try {
    /*if (user.value.role === 'MANAGER' && user.value.department !== user.value.managedDepartment) {
      alert("Ein Abteilungsleiter muss in der Abteilung arbeiten, die er leitet.")
    } else {
      await userStore.registerUser(user.value);
      createSuccess.value = true;
    }*/
    if (user.value.role === 'MANAGER') {
      user.value.managedDepartment = user.value.department;
      await userStore.registerUser(user.value);
      createSuccess.value = true;
    } else {
      await userStore.registerUser(user.value);
      createSuccess.value = true;
    }
  } catch (error) {
    if (error.response) {
      // The request was made and the server responded with a status code
      // that falls out of the range of 2xx
      if (error.response.status === 401) {
        console.log('Unauthorized', error);
        // Handle the unauthorized error here
      } else if (error.response.status === 409) {
        console.error('DB Conflict', error);
      }else if (error.response.status === 403) {
        console.log('Forbidden! only ADMINS are allowed to create accounts.', error)
      } else {
        console.error('HTTP error', error.response.status);
      }
    } else if (error.request) {
      // The request was made but no response was received
      console.error('No response received', error.request);
    } else {
      // Something happened in setting up the request that triggered an Error
      console.error('Error', error.message);
    }
  }
}
</script>

<style scoped>

</style>